using System;
using System.Collections.Generic;
using System.Text;

namespace AutoBroker
{
    class AnyValueIndicator : Indicator
    {
        private IValues storedValues = null;

        public AnyValueIndicator(IValues values)
        {
            ComputeFor(values);
        }

        protected override void ComputeFor(IValues values)
        {
            storedValues = values.Clone();
        }

        public override float GetValue(int index)
        {
            if (storedValues == null) return float.NaN;
            return storedValues.GetValue(index);
        }

        public override int GetNumValues()
        {
            if (storedValues == null) return 0;
            return storedValues.GetNumValues();
        }
    }
}
