using System;
using System.Collections.Generic;
using System.Data;
using System.Text;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace AutoBroker
{

    public class IndicatorRelationIndicator : Indicator 
    {
        private List<float> relationValues = null;

        public IndicatorRelationIndicator(Indicator firstValues, Indicator secondValues)            
        {
            relationValues = new List<float>(firstValues.GetNumValues());
            for (int i = 0; i < firstValues.GetNumValues(); i++)
            {
                relationValues.Add(firstValues.GetValue(i) / secondValues.GetValue(i));
            }
        }

        protected override void ComputeFor(IValues values)
        {            
        }

        public override float GetValue(int index)
        {
            return relationValues[index];
        }

        public override int GetNumValues()
        {
            return relationValues.Count;
        }
    }
}
