using System;
using System.Collections.Generic;
using System.Text;

namespace AutoBroker
{
    public struct ValueRep
    {
        private static string decimalSep = System.Globalization.CultureInfo.CurrentCulture.NumberFormat.NumberDecimalSeparator;

        public int RawValue;

        public ValueRep(float value)
        {
            RawValue = FromFloat(value);
        }

        public ValueRep(string value)
        {
            RawValue = FromString(value);
        }

        public float ToFloat()
        {
            return 0.01f * (float)RawValue;
        }

        public int ToDecInt()
        {
            return RawValue;
        }

        public static int FromFloat(float value)
        {
            return (int) Math.Round(value * 100.0);
        }

        private static int FromString(string value)
        {
            return (int)(Decimal.Parse(value) * 100.0m);
        }

        public override string ToString()
        {            
            return (RawValue / 100).ToString() + decimalSep + (RawValue % 100).ToString("D2");
        }

        public string Serialize()
        {
            return ToString();
        }

        internal static ValueRep Deserialize(string p)
        {
            return new ValueRep(p);
        }
    }
}
