using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace AutoBroker
{
    public partial class AddTransaction : Form
    {
        public float Provision = 0.0f;
        public float TotalPrice = 0.0f;

        public AddTransaction()
        {
            InitializeComponent();
        }

        public void SetStocks(Stocks stocksList)
        {
            comboBoxStocks.Items.Clear();
            if (stocksList == null) return;
            foreach (StockInfo stock in stocksList.stockInfo)
            {
                comboBoxStocks.Items.Add(stock.GetFullName());
            }
        }        

        private void UpdateDerivedData()
        {
            float price = 0.0f;
            int quantity = 0;
            try
            {
                price = float.Parse(textBoxPrice.Text);
                quantity = int.Parse(textBoxQuantity.Text);
            }
            catch
            {
            }
            if (chkNoProvision.Checked)
            {
                Provision = 0;
            }
            else
            {
                Provision = Transaction.ComputeNormalProvision(price * quantity);
            }
            TotalPrice = -price * quantity - Provision;
            labelTotalPrice.Text = TotalPrice.ToString("F2");
            labelProvision.Text = Provision.ToString("F2");
        }

        public Transaction GetResultTransaction()
        {
            Transaction trans = new Transaction();
            try
            {
                trans.StockName = comboBoxStocks.Text;
                trans.SingleStockValue = new ValueRep(float.Parse(this.textBoxPrice.Text));
                trans.StockQuantityDelta = int.Parse(this.textBoxQuantity.Text);
                trans.Provision = new ValueRep(Provision);
                trans.Time = this.monthCalendar1.SelectionStart;                
            }
            catch
            {
                return null;
            }
            return trans;
        }

        private void AddTransaction_Load(object sender, EventArgs e)
        {
        }

        private void textBoxQuantity_TextChanged(object sender, EventArgs e)
        {
            UpdateDerivedData();
        }

        private void textBoxPrice_TextChanged(object sender, EventArgs e)
        {
            UpdateDerivedData();
        }
    }
}