using System;
using System.Collections.Generic;
using System.Data;
using System.Text;

namespace AutoBroker
{
    public interface IValues
    {
        int GetNumValues();

        float GetValue(int index);

        int GetDecIntValue(int index);

        void GetMinMaxValue(out float min, out float max);

        void GetMinMaxValueForLast(int lastCount, out float min, out float max);

        IValues Clone();
    }

    public abstract class IValuesUtils
    {
        public static IValues[] Split(IValues values, int splitIndex)
        {
            AnyValues values1 = new AnyValues();
            AnyValues values2 = new AnyValues();

            for (int i=0; i< splitIndex; i++)
            {
                values1.AddValue(new ValueRep(values.GetValue(i)));
            }
            for (int i = splitIndex; i < values.GetNumValues(); i++)
            {
                values2.AddValue(new ValueRep(values.GetValue(i)));
            }
            IValues[] splitVals = new IValues[2];
            splitVals[0] = values1;
            splitVals[1] = values2;
            return (splitVals);
        }
    }

}
